import { Bitmap } from '../Bitmap';
export class BaseSource {
    canvas;
    ctx;
    isInit;
    constructor() {
        this.canvas = document.createElement('canvas');
        this.ctx = this.canvas.getContext('2d');
        this.isInit = false;
    }
    init() {
        if (!this.isInit) {
            this.initCanvas();
            this.isInit = true;
        }
    }
    getBitmap() {
        this.init();
        this.draw();
        const { width, height } = this.canvas;
        const pixels = this.ctx.getImageData(0, 0, width, height).data;
        return new Bitmap(width, height, pixels);
    }
}
